# coding: utf-8

"""
    OrderCloud

    No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)

    OpenAPI spec version: 1.0
    Contact: ordercloud@four51.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class PriceScheduleApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def create(self, price_schedule, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create(price_schedule, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param PriceSchedule price_schedule:  (required)
        :return: PriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.create_with_http_info(price_schedule, **kwargs)
        else:
            (data) = self.create_with_http_info(price_schedule, **kwargs)
            return data

    def create_with_http_info(self, price_schedule, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.create_with_http_info(price_schedule, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param PriceSchedule price_schedule:  (required)
        :return: PriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['price_schedule']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'price_schedule' is set
        if ('price_schedule' not in params) or (params['price_schedule'] is None):
            raise ValueError("Missing the required parameter `price_schedule` when calling `create`")

        resource_path = '/priceschedules'.replace('{format}', 'json')
        path_params = {}

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'price_schedule' in params:
            body_params = params['price_schedule']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='PriceSchedule',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def delete(self, price_schedule_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete(price_schedule_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.delete_with_http_info(price_schedule_id, **kwargs)
        else:
            (data) = self.delete_with_http_info(price_schedule_id, **kwargs)
            return data

    def delete_with_http_info(self, price_schedule_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_with_http_info(price_schedule_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['price_schedule_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'price_schedule_id' is set
        if ('price_schedule_id' not in params) or (params['price_schedule_id'] is None):
            raise ValueError("Missing the required parameter `price_schedule_id` when calling `delete`")

        resource_path = '/priceschedules/{priceScheduleID}'.replace('{format}', 'json')
        path_params = {}
        if 'price_schedule_id' in params:
            path_params['priceScheduleID'] = params['price_schedule_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'DELETE',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def delete_price_break(self, price_schedule_id, quantity, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_price_break(price_schedule_id, quantity, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :param int quantity: Quantity of the price schedule. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.delete_price_break_with_http_info(price_schedule_id, quantity, **kwargs)
        else:
            (data) = self.delete_price_break_with_http_info(price_schedule_id, quantity, **kwargs)
            return data

    def delete_price_break_with_http_info(self, price_schedule_id, quantity, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_price_break_with_http_info(price_schedule_id, quantity, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :param int quantity: Quantity of the price schedule. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['price_schedule_id', 'quantity']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_price_break" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'price_schedule_id' is set
        if ('price_schedule_id' not in params) or (params['price_schedule_id'] is None):
            raise ValueError("Missing the required parameter `price_schedule_id` when calling `delete_price_break`")
        # verify the required parameter 'quantity' is set
        if ('quantity' not in params) or (params['quantity'] is None):
            raise ValueError("Missing the required parameter `quantity` when calling `delete_price_break`")

        resource_path = '/priceschedules/{priceScheduleID}/PriceBreaks'.replace('{format}', 'json')
        path_params = {}
        if 'price_schedule_id' in params:
            path_params['priceScheduleID'] = params['price_schedule_id']

        query_params = {}
        if 'quantity' in params:
            query_params['quantity'] = params['quantity']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'DELETE',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type=None,
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def get(self, price_schedule_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get(price_schedule_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :return: PriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_with_http_info(price_schedule_id, **kwargs)
        else:
            (data) = self.get_with_http_info(price_schedule_id, **kwargs)
            return data

    def get_with_http_info(self, price_schedule_id, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_with_http_info(price_schedule_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :return: PriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['price_schedule_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'price_schedule_id' is set
        if ('price_schedule_id' not in params) or (params['price_schedule_id'] is None):
            raise ValueError("Missing the required parameter `price_schedule_id` when calling `get`")

        resource_path = '/priceschedules/{priceScheduleID}'.replace('{format}', 'json')
        path_params = {}
        if 'price_schedule_id' in params:
            path_params['priceScheduleID'] = params['price_schedule_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='PriceSchedule',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def list(self, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str search: Word or phrase to search for.
        :param str search_on: Comma-delimited list of fields to search on.
        :param str sort_by: Comma-delimited list of fields to sort by.
        :param int page: Page of results to return. Default: 1
        :param int page_size: Number of results to return per page. Default: 20, max: 100.
        :param dict(str, str) filters: Any additional key/value pairs passed in the query string are interpretted as filters. Valid keys are top-level properties of the returned model or 'xp.???'
        :return: ListPriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.list_with_http_info(**kwargs)
        else:
            (data) = self.list_with_http_info(**kwargs)
            return data

    def list_with_http_info(self, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.list_with_http_info(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str search: Word or phrase to search for.
        :param str search_on: Comma-delimited list of fields to search on.
        :param str sort_by: Comma-delimited list of fields to sort by.
        :param int page: Page of results to return. Default: 1
        :param int page_size: Number of results to return per page. Default: 20, max: 100.
        :param dict(str, str) filters: Any additional key/value pairs passed in the query string are interpretted as filters. Valid keys are top-level properties of the returned model or 'xp.???'
        :return: ListPriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['search', 'search_on', 'sort_by', 'page', 'page_size', 'filters']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list" % key
                )
            params[key] = val
        del params['kwargs']

        resource_path = '/priceschedules'.replace('{format}', 'json')
        path_params = {}

        query_params = {}
        if 'search' in params:
            query_params['search'] = params['search']
        if 'search_on' in params:
            query_params['searchOn'] = params['search_on']
        if 'sort_by' in params:
            query_params['sortBy'] = params['sort_by']
        if 'page' in params:
            query_params['page'] = params['page']
        if 'page_size' in params:
            query_params['pageSize'] = params['page_size']
        if 'filters' in params:
            query_params['filters'] = params['filters']

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'GET',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='ListPriceSchedule',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def patch(self, price_schedule_id, price_schedule, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.patch(price_schedule_id, price_schedule, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :param PriceSchedule price_schedule:  (required)
        :return: PriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.patch_with_http_info(price_schedule_id, price_schedule, **kwargs)
        else:
            (data) = self.patch_with_http_info(price_schedule_id, price_schedule, **kwargs)
            return data

    def patch_with_http_info(self, price_schedule_id, price_schedule, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.patch_with_http_info(price_schedule_id, price_schedule, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :param PriceSchedule price_schedule:  (required)
        :return: PriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['price_schedule_id', 'price_schedule']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method patch" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'price_schedule_id' is set
        if ('price_schedule_id' not in params) or (params['price_schedule_id'] is None):
            raise ValueError("Missing the required parameter `price_schedule_id` when calling `patch`")
        # verify the required parameter 'price_schedule' is set
        if ('price_schedule' not in params) or (params['price_schedule'] is None):
            raise ValueError("Missing the required parameter `price_schedule` when calling `patch`")

        resource_path = '/priceschedules/{priceScheduleID}'.replace('{format}', 'json')
        path_params = {}
        if 'price_schedule_id' in params:
            path_params['priceScheduleID'] = params['price_schedule_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'price_schedule' in params:
            body_params = params['price_schedule']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'PATCH',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='PriceSchedule',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def save_price_break(self, price_schedule_id, price_break, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.save_price_break(price_schedule_id, price_break, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :param PriceBreak price_break:  (required)
        :return: PriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.save_price_break_with_http_info(price_schedule_id, price_break, **kwargs)
        else:
            (data) = self.save_price_break_with_http_info(price_schedule_id, price_break, **kwargs)
            return data

    def save_price_break_with_http_info(self, price_schedule_id, price_break, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.save_price_break_with_http_info(price_schedule_id, price_break, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :param PriceBreak price_break:  (required)
        :return: PriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['price_schedule_id', 'price_break']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method save_price_break" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'price_schedule_id' is set
        if ('price_schedule_id' not in params) or (params['price_schedule_id'] is None):
            raise ValueError("Missing the required parameter `price_schedule_id` when calling `save_price_break`")
        # verify the required parameter 'price_break' is set
        if ('price_break' not in params) or (params['price_break'] is None):
            raise ValueError("Missing the required parameter `price_break` when calling `save_price_break`")

        resource_path = '/priceschedules/{priceScheduleID}/PriceBreaks'.replace('{format}', 'json')
        path_params = {}
        if 'price_schedule_id' in params:
            path_params['priceScheduleID'] = params['price_schedule_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'price_break' in params:
            body_params = params['price_break']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'POST',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='PriceSchedule',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))

    def update(self, price_schedule_id, price_schedule, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.update(price_schedule_id, price_schedule, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :param PriceSchedule price_schedule:  (required)
        :return: PriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.update_with_http_info(price_schedule_id, price_schedule, **kwargs)
        else:
            (data) = self.update_with_http_info(price_schedule_id, price_schedule, **kwargs)
            return data

    def update_with_http_info(self, price_schedule_id, price_schedule, **kwargs):
        """
        
        

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.update_with_http_info(price_schedule_id, price_schedule, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param str price_schedule_id: ID of the price schedule. (required)
        :param PriceSchedule price_schedule:  (required)
        :return: PriceSchedule
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['price_schedule_id', 'price_schedule']
        all_params.append('callback')
        all_params.append('_return_http_data_only')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'price_schedule_id' is set
        if ('price_schedule_id' not in params) or (params['price_schedule_id'] is None):
            raise ValueError("Missing the required parameter `price_schedule_id` when calling `update`")
        # verify the required parameter 'price_schedule' is set
        if ('price_schedule' not in params) or (params['price_schedule'] is None):
            raise ValueError("Missing the required parameter `price_schedule` when calling `update`")

        resource_path = '/priceschedules/{priceScheduleID}'.replace('{format}', 'json')
        path_params = {}
        if 'price_schedule_id' in params:
            path_params['priceScheduleID'] = params['price_schedule_id']

        query_params = {}

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'price_schedule' in params:
            body_params = params['price_schedule']

        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])
        if not header_params['Accept']:
            del header_params['Accept']

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json', 'text/plain; charset=utf-8'])

        # Authentication setting
        auth_settings = ['oauth2']

        return self.api_client.call_api(resource_path, 'PUT',
                                            path_params,
                                            query_params,
                                            header_params,
                                            body=body_params,
                                            post_params=form_params,
                                            files=local_var_files,
                                            response_type='PriceSchedule',
                                            auth_settings=auth_settings,
                                            callback=params.get('callback'),
                                            _return_http_data_only=params.get('_return_http_data_only'))
